This setup guide is for v1 of the JavaScript SDK (currently in beta).
- Get detailed metrics on API usage, errors, and performance
- Track API adoption and usage by individual consumers
- Log individual API requests, responses, and correlated application logs
- See what’s causing slow API requests with traces
- Monitor uptime and set up custom alerts
Requirements
Requires Node.js 20.6+ and either Express 4.18.2+ or Express 5.x.Create app
To get started, create a new app in the Apitally dashboard and select Express as your framework.
You can also configure the environments (e.g. prod and dev) for your app, or simply accept the defaults.
After submitting, you will see tailored setup instructions for your app. These include your write token and code snippets you can copy and paste into your project.
The write token (
apt_...) provided in the setup instructions uniquely identifies your app for the purpose of data ingestion only. It does not grant any kind of read access to your data.Install the SDK
Install the Apitally SDK as a dependency in your project.Initialize Apitally
Importapitally/express/register on the first line of your application’s entry file, before any other imports. This ensures routes are captured even in routers defined in other modules.
Then call useApitally with your Express application, the write token, and other configuration options after creating the app.
APITALLY_WRITE_TOKEN and APITALLY_ENV environment variables instead of passing writeToken and env in code.
Deploy your application with these changes, or restart it if you’re testing locally.
The basic setup is now complete. Metrics and logs will start appearing in the Apitally
dashboard.
Identify consumers
Consumers are the users or applications calling your API. Identifying them lets you analyze and filter API traffic by consumer in Apitally. CallsetConsumer during request handling to associate the current request with a consumer identifier. You can call it wherever the consumer is known, such as in a route handler, existing middleware, or authentication code.
You can also provide a display name and group for each consumer.
Capture headers and bodies
Only response headers are captured by default. You can opt in to capture request headers as well as request and response bodies when initializing Apitally.Mask sensitive information
The SDK automatically masks common sensitive query parameters, headers, and body fields. To mask additional data, pass regular expressions matching query parameter names, header names, or body field names tomaskQueryParams, maskHeaders, or maskBodyFields, respectively. Use the i flag for case-insensitive matching.
maskRequestBody and maskResponseBody callbacks to mask individual fields or entire bodies using custom logic. Use maskLogRecord to mask or drop application log records.
More information about masking is available here.
Sample requests
If your application receives a lot of traffic, you may want to sample requests to stay within your request logs quota. Metrics will continue to count every request regardless of sampling. UsesampleRate to capture logs and traces for a fraction of requests.
sampleOnRequest and sampleOnResponse callbacks to make sampling decisions using custom logic.
More information about sampling is available here.
Instrument third-party libraries
Instrumenting third-party libraries adds details about database queries, HTTP calls to external services, and other operations to your request traces. This lets you see how these operations contribute to API response times. Use OpenTelemetry instrumentation packages to instrument the libraries you want to trace. For example, to trace database queries made withpg, install @opentelemetry/instrumentation and @opentelemetry/instrumentation-pg:
instrumentation.mjs file that registers the instrumentation:
instrumentation.mjs
pg is imported: